************************************************************************
* File (main_nc_vegas_1413_1211.F).
************************************************************************
* This is the main FORTRAN module to calculate 1-loop EW radiative
* correction for dn + up -> el + en process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      program main_cc_1413_1211
      implicit none!
#include "s2n_declare.h"

      integer ome,lmu,imu,tbprint,intflag,isetup
      integer j,is,ic,ii,jj,imlc,ihard
      integer ncall,itmx,nprn,ndev
      real*8 sq,born_sd,virt_sd,hard_sd,DelSV_MS,DelH_MS,DelH_MS_sd
      real*8 xl(10),xu(10),x1cut,acc,dummy,avgi,sd,chi2a
      complex*16 ffb(10,5,8)
      real*8 costa(5),sa(8),sres(4,10,8)
      real*8 ranini
      real*8 Mfscale
      common /bveg1/ ncall, itmx, nprn, ndev, xl, xu, acc
      common /s/ s
      common /Mfscale/ Mfscale
      external function_1c_1413_1211,function_1spr_1413_1211
      external function_1s_1413_1211,function_4d_1413_1211

      data costa/-0.9d0, -0.5d0, 0d0, +0.5d0, +0.9d0/
      data sa/40d0,80d0,120d0,200d0,500d0,1000d0,2000d0,14000d0/
*
*     iqed = 0      /1   /2  /3  /4  /5
*            without/with/ISR/IFI/FSR/[IFI+FSR] QED corrections
*     iew = 1   /0
*           with/without EW corrections
*     iborn = 1   /0
*             Born/Born+1loop
*     gfscheme = 0       /1 /2
*                alpha(0)/GF/GF prime scheme
*     ilin = 0      /1
*            without/with linearization
*     ifgg = -1/0    /1                 /2 
*     ffgg =  0/zoro /[zoro+coeff*ff_gg]/[zoro/(1d0 - coeff*ff_gg)]
*     ihard = 1   /4
*             1spr/4d integration for hard
*     isetup = 0   /1                   /2
*              SANC/Les Houches Workshop/TeV4LHCW setups
*
      ichep = 0
      iqed = 1
      iew = 1
      iborn = 0
      gfscheme = 0
      ilin = 1
      ifgg = 1
      ihard = 1
      isetup = 1

      nc = 1d0
      fc = 3d0

      if (isetup.eq.0) then
#include "sanc_input.h"
         print *, "SANC setup"
      elseif (isetup.eq.1) then
#include "leshw_input.h"
         print *, "Les Houches setup"
      elseif (isetup.eq.2) then
#include "tev4lhcw_input.h"
         print *, "TeV4LHC setup"
      endif

*      mup = mup/10d0
*      mdn = mdn/10d0

      call s2n_init()
      call ffini()

      Mfscale = mw
      print *, ''
      print *, "flag qed  = ",iqed
      print *, "flag ew   = ",iew
      print *, "flag ilin = ",ilin
      print *, "alphai    = ",alphai
      print *, "alpha     = ",alpha
      print *, "GF(GeV-^2)= ",gf
      print *, "g         = ",g
      print *, "e         = ",e
      print *, "cwm       = ",ctw
      print *, "swm2      = ",stw2
      print *, "mh(GeV)  = ",mh
      print *, "mw(GeV)  = ",mw
      print *, "mz(GeV)  = ",mz
      print *, "wz(GeV)  = ",wz
      print *, "ww(GeV)  = ",ww
      print *, "wh(GeV)  = ",wh
      print *, "wtp(GeV) = ",wtp
      print *, ""
      print *, "Proccess  dn + up --> el + en"
      print *, ""
      print *, "mup(GeV) =", mup
      print *, "mdn(GeV) =", mdn
      print *, "mel(GeV) =", mel
      mf = mel

      do imu=1,1
      if(imu.eq.1) thmu = mw
      if(imu.eq.2) thmu = mw/10d0
      do lmu=2,2
      if(lmu.eq.1) tlmu2 = 1d-1
      if(lmu.eq.2) tlmu2 = 1d-2
      thmu2 = thmu**2
      print *, ''
      print *, "thmu(GeV)    = ", thmu
      print *, "thla2(GeV^2) = ", tlmu2

      nprn = 0
*      call srand (time ())
      dummy = ranini(12345)

      do is=1,8
         sq = sa(is)
         s  = sq**2
         betaf = 1d0 
         print *, ""
         print *, "sqrt(s)(GeV)   = ", sq

*     born
         xl(1) = -1d0
         xu(1) = +1d0

         iborn = 1
         ncall = 10 000
         itmx = 10
         call vegas (1, function_1c_1413_1211, avgi, sd, chi2a)
         itmx = 10
         call vegas1 (1, function_1c_1413_1211, avgi, sd, chi2a)
         born = avgi
         born_sd = sd

      do ome = 1,2
         if (ome.eq.1) omega = 1d-4*sq/2
         if (ome.eq.2) omega = 1d-5*sq/2

         print *, ""
         print *, "omega(GeV)     = ", omega

*     virt+soft
         x1cut = 1d-15
         xl(1) = -1d0+x1cut
         xu(1) = +1d0-x1cut

         iborn = 0
         ncall = 10 000
         itmx = 10
         call vegas (1, function_1c_1413_1211, avgi, sd, chi2a)
         itmx = 10
         call vegas1 (1, function_1c_1413_1211, avgi, sd, chi2a)
         virt = avgi
         virt_sd = sd

*     DelSV_MS
*     see Brem_4f_CC.frm [#if `SubtScheme' = 1;*** MSbar subtraction]
         DelSV_MS=alpha/2/pi*qup**2*
     & (log(Mfscale**2/mup**2)*log(4d0*omega**2/s)
     &     + 3d0/2*log(Mfscale**2/mup**2) - log(4d0*omega**2/s) - 3d0/2
     &     - 1d0/2*log(4d0*omega**2/s)**2 + 7d0/2)*born
     &           +alpha/2/pi*qdn**2*
     & (log(Mfscale**2/mdn**2)*log(4d0*omega**2/s)
     &     + 3d0/2*log(Mfscale**2/mdn**2) - log(4d0*omega**2/s) - 3d0/2
     &     - 1d0/2*log(4d0*omega**2/s)**2 + 7d0/2)*born

*     DelH_MS
         xl(1) = mel**2/s
         xu(1) = (s-2d0*sq*omega)/s

         iborn = 1
         ncall = 10 000
         itmx = 10
         call vegas (1, function_1s_1413_1211, avgi, sd, chi2a)
         itmx = 10
         call vegas1 (1, function_1s_1413_1211, avgi, sd, chi2a)
         DelH_MS = avgi
         DelH_MS_sd = sd

         if (iqed.ge.1) then
            if (ihard.eq.1) then

*     hard, 1spr
               xl(1) = mel**2
               xu(1) = s-2d0*sq*omega

               ncall = 50 000
               itmx = 10
               call vegas (1, function_1spr_1413_1211, avgi, sd, chi2a)
               itmx = 10
               call vegas1 (1, function_1spr_1413_1211, avgi, sd, chi2a)
               hard = avgi
               hard_sd = sd

            elseif (ihard.eq.4) then

*     hard, 4d
               xl(1) = mel**2
               xu(1) = s-2d0*sq*omega
               xl(2) = 0d0
               xu(2) = 2d0*pi
               xl(3) = -1d0
               xu(3) = +1d0
               xl(4) = -1d0
               xu(4) = +1d0

               ncall = 1 000 000
               itmx = 20
               call vegas (4, function_4d_1413_1211, avgi, sd, chi2a)
               itmx = 20
               call vegas1 (4, function_4d_1413_1211, avgi, sd, chi2a)
               hard = avgi
               hard_sd = sd

            endif
         else
            hard = 0d0
            hard_sd = 0d0
         endif

         print *, "sq(GeV)        = ", sq
         print *, "omega(GeV)     = ", omega
         print *, "[bo](pb)       = ", born, born_sd
         print *, "[vi+so](pb)    = ", virt, virt_sd
         print *, "[ha](pb)       = ", hard, hard_sd
         print *, "[DelH_MS](pb)  = ", DelH_MS,DelH_MS_sd
         print *, "[1loop](pb)    = ", virt+hard,
     &        sqrt(virt_sd**2+hard_sd**2)
         print *, "[delta](%)     = ",(virt-born+hard)/born*100d0,
     &        sqrt(virt_sd**2+hard_sd**2)/born*100d0
         print *, "[1loop_MS](pb) = ", virt+hard-DelSV_MS-DelH_MS,
     &        sqrt(virt_sd**2+hard_sd**2+DelH_MS_sd**2)
         print *, "[delta_MS](%)  = ",(virt-born+hard-DelSV_MS-DelH_MS)
     &  /born*100d0,sqrt(virt_sd**2+hard_sd**2+DelH_MS_sd**2)/born*100d0

      enddo
      enddo
      enddo
      enddo

      stop
      end
***************************************************************
      real*8 function function_1c_1413_1211(x,wgt)
      implicit none!
#include "s2n_declare.h"
      real*8 x(10),wgt
      common /s/ s

      cosf = x(1)
      sinf = sqrt(1d0-cosf**2)

      t    = - (s-mf**2)/2d0*(1d0+cosf)
      u    = - (s-mf**2)/2d0*(1d0-cosf)

      if (iborn.eq.1) then
         call cc_br_1413_1211 (-s,-t,-u,born,soft,hard)
         function_1c_1413_1211 = born
         return
      elseif (iborn.eq.0) then
         call cc_br_1413_1211 (-s,-t,-u,born,soft,hard)
         call cc_si_1413_1211 (s,t,u,sigma)
         function_1c_1413_1211 = sigma+soft
         if (iqed.eq.0) then
            function_1c_1413_1211 = sigma
         endif
         return
      else
         print *, "wrong iborn values = ", iborn
         function_1c_1413_1211 = 0d0
      endif

      return
      end
************************************************************
      real*8 function function_1spr_1413_1211(x,wgt)
      implicit none!
#include "s2n_declare.h"
      real*8 x(10),wgt
      common /s/ s

      spr = x(1)

      call cc_ha_1413_1211_1spr (s,spr,hard)

      function_1spr_1413_1211 = hard
      if (hard.lt.0d0) then
*         function_1spr_1413_1211 = 0d0
*         print *, "hard < 0"
      endif

      return
      end
*************************************************************
      real*8 function function_1s_1413_1211(x,wgt)
      implicit none!
#include "s2n_declare.h"
      real*8 x(10),wgt,ksi,bornk
      real*8 Mfscale
      common /s/ s
      common /Mfscale/ Mfscale

      ksi = x(1)

      call cc_bo_1413_1211(s*ksi,bornk)

*     see Eq.(12) DYCC
      function_1s_1413_1211 =
     &  alpha/2/pi*qup**2*(
     & (1d0+ksi**2)/(1d0-ksi)*(log(Mfscale**2/mup**2)
     &  -2d0*log(1d0-ksi)-1d0))
     & *(bornk)
     & +alpha/2/pi*qdn**2*(
     & (1d0+ksi**2)/(1d0-ksi)*(log(Mfscale**2/mdn**2)
     &  -2d0*log(1d0-ksi)-1d0))
     & *(bornk)

      return
      end
*************************************************************
      real*8 function function_4d_1413_1211(x,wgt)
      implicit none!
#include "s2n_declare.h"
      real*8 x(10),wgt,ph3,cth3,cth5
      common /s/ s

      spr = x(1)
      ph3 = x(2)
      cth3 = x(3)
      cth5 = x(4)

      call cc_ha_1413_1211 (s,spr,ph3,cth3,cth5,hard)

      function_4d_1413_1211 = hard
      if (hard.lt.0d0) then
*         function_4d_1413_1211 = 0d0
*         print *, "hard < 0"
      endif

      return
      end
************************************************************
